#!/bin/bash

CURL="/usr/bin/curl"

if [ "$#" -ne "4" ] ; then
		NAME=$(basename "$0")
        echo "Usage: $NAME AP-IP username password new-WPAKey"
        exit 1
fi

APIP="$1"
CREDENTIALS="$2:$3"
WPAKEY="$3"

$CURL --connect-timeout 5 --user "$CREDENTIALS" -d "submit_button=WL_WPATable&action=ApplyTake&change_action=gozila_cgi&submit_type=save&security_varname=&security_mode_last=&wl_wep_last=&filter_mac_value=&wl0_security_mode=psk&wl0_crypto=tkip%2Baes&wl0_wpa_psk=$WPAKEY&wl0_wpa_gtk_rekey=3600" "http://$APIP/apply.cgi" &>/dev/null

if [ "$?" -eq "0" ] ; then
        echo "WPA Key changed"
        exit 0
else
        echo "Something went wrong"
        exit 1
fi